/* GCC */

#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>

using namespace std;
ifstream fin("square.in");
ofstream fout("square.out");



void show(vector< vector<int> > a){
    for(int i=0; i<a.size(); i++){
        for(int z=0; z<a[0].size(); z++){
            cout<<a[i][z]<<' ';
        }
        cout<<endl;
    }
    cout<<endl;
}

/*int findNum(int a, vector<int> b){
    for(int i=0; i<b.size(); i++){
        if(b[i]==a) return i;
    }
    return -1;
}*/


int n;
int l;
vector< vector<int> > pos;

vector<int> checkSquares(vector< vector<int> > a){
    vector<int> ans;
    //check |
    for(int i=0; i<a.size(); i++){
        bool up=true, down=true;
        for(int z=1; z<a.size()/2; z++){
            if(a[z][i]!=a[0][i]){
                up=false;
                break;
            }
        }
        if(!up) for(int z=a.size()/2; z<a.size(); z++){
            if(a[z][i]!=a[a.size()-1][i]){
                down=false;
                break;
            }
        }
        if(!up && !down) {
            ans.push_back(-i-1);
        }
    }
    //check --
    for(int i=0; i<a.size(); i++){
        bool left=true, right=true;
        for(int z=1; z<a.size()/2; z++){
            if(a[i][z]!=a[i][0]){
                left=false;
                break;
            }
        }
        if(!left) for(int z=a.size()/2; z<a.size(); z++){
            if(a[i][z]!=a[i][a.size()-1]){
                right=false;
                break;
            }
        }
        if(!left && !right) {
            ans.push_back(i+1);
        }
    }
    return ans;
}

vector< vector<int> > getNew(vector< vector<int> > curr, int ch){
    int s=curr.size();
    if(ch<0){
        ch*=-1;
        ch--;
        for(int i=0; i<s/2; i++){
            swap(curr[i][ch], curr[i][s-1-ch]);
        }
    } else {

        ch--;
        for(int i=0; i<s/2; i++){
            swap(curr[ch][i], curr[ch][s-1-i]);
        }

    }
    return curr;
}

void solvePos(){
    vector< vector< vector<int> > > line;
    vector<int> was;
    int size=0;
    line.push_back(pos);
    was.push_back(0);
    do{
        vector<int> possible=checkSquares(line[0]);
        if(possible.empty()) return;
        for(int i=0; i<possible.size(); i++){
            if(possible[i]==was[0]) continue;
            line.push_back(getNew(pos, possible[i]));
            was.push_back(possible[i]);
            /*show(line[size]);
            int k;
            cin>>k;*/
            size++;
            break;
        }
        show(line[0]);
        cout<<was[0]<<endl;
        line.erase(line.begin());
        was.erase(was.begin());
        size--;
    }while(size!=-1);
}

int main(){

    fin>>n;
    int i, z;
    for(i=0; i<n; i++){
        //Starting new test
        fin>>l;
        l*=2;
        vector< int > nums(101, 0);
        pos=vector< vector<int> >(l, vector<int>(l));

        //File in
        for(z=0; z<l; z++){
            for(int t=0; t<l; t++){
                fin>>pos[z][t];
                nums[pos[z][t]]++;

            }
        }
        //check if only 4 numbers
        bool noSol=false;
        for(z=1; z<=100; z++){
            if(nums[z]!=0 && nums[z]%((l*l)/4)!=0) {
                noSol=true;
                break;
            }
        }

        //File out
        /*if(noSol) fout<<-1<<endl;
         else solvePos();*/

        fout<<-1<<endl;
    }

    fin.close();
    fout.close();
    return 0;
}
