#include <iostream>
#include <cmath>
#include <algorithm>
#include <cstdio>

using namespace std;

int n, x[300000], y[300000], root, it, par[300000], r[300000];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    freopen("nests.in", "r", stdin);
    freopen("nests.out", "w",stdout);

    cin >> n;
    for(int i = 1; i <= n; i++) {
        cin >> x[i] >> y[i];
        if(i == 1 || y[i] > y[root]) {
            par[root] = i;
            root = i;
            it = i;
        } else {
            while(y[it] < y[i])
                it = par[it];

            par[r[it]] = i;
            r[it] = i;
            par[i] = it;
            it = i;
        }
    }

    long long ans = 0;
    for(int i = 1; i <= n; i++)
        if(i != root)
            ans += abs(x[i] - x[par[i]]) + abs(y[i] - y[par[i]]);

    cout << ans << '\n';
}
