/* GCC */
#include<cstdio>
#include<vector>
#include<algorithm>
#include<utility>
using namespace std;

vector<pair<char,int> > Move;

int n, m;

bool check(vector<int> a, vector<int> b){
    int aa;
    if(a == b) return false;
    if(a[3] == b[0]){
        aa = a[3];
        a[3] = a[2];
        a[2] = a[1];
        a[1] = aa;
    }
    while(a[0] != b[0]){
        aa = a[2];
        a[2] = a[1];
        a[1] = a[0];
        a[0] = aa;
    }
    while(a[1] != b[1]){
        aa = a[3];
        a[3] = a[2];
        a[2] = a[1];
        a[1] = aa;
        //printf("$");
    }
    if(a[2] == b[2]) return false;
    sort(a.begin(), a.end());
    for(int i = 0; i < 3; i++) if(a[i] == a[i+1]) return false;
    return true;
}

void mov(vector<int> a, vector<int> b, int ii, int jj){
    int aa;
    if(a == b) return;
    if(a[3] == b[0]){
        aa = a[3];
        a[3] = a[2];
        a[2] = a[1];
        a[1] = aa;
        Move.push_back(make_pair('-', m-jj-1));
        Move.push_back(make_pair('+', m-ii-1));
        Move.push_back(make_pair('-', m-jj-1));
        Move.push_back(make_pair('+', m-ii-1));
    }
    while(a[0] != b[0]){
        aa = a[2];
        a[2] = a[1];
        a[1] = a[0];
        a[0] = aa;
        Move.push_back(make_pair('+', ii));
        Move.push_back(make_pair('-', m-jj-1));
        Move.push_back(make_pair('+', ii));
        Move.push_back(make_pair('-', m-jj-1));
    }
    while(a[1] != b[1]){
        aa = a[3];
        a[3] = a[2];
        a[2] = a[1];
        a[1] = aa;
        Move.push_back(make_pair('-', m-jj-1));
        Move.push_back(make_pair('+', m-ii-1));
        Move.push_back(make_pair('-', m-jj-1));
        Move.push_back(make_pair('+', m-ii-1));
        //printf("$");
    }
    if(a[2] == b[2]) return;

    if(a[1] == a[3] || a[1] == a[2]) {
        while(a != b){
            aa = a[3];
            a[3] = a[2];
            a[2] = a[1];
            a[1] = aa;
            Move.push_back(make_pair('-', m-jj-1));
            Move.push_back(make_pair('+', m-ii-1));
            Move.push_back(make_pair('-', m-jj-1));
            Move.push_back(make_pair('+', m-ii-1));
        }
        return;
    }

    if(a[0] == a[1]) {
        aa = a[3];
        a[3] = a[2];
        a[2] = a[1];
        a[1] = aa;
        Move.push_back(make_pair('-', m-jj-1));
        Move.push_back(make_pair('+', m-ii-1));
        Move.push_back(make_pair('-', m-jj-1));
        Move.push_back(make_pair('+', m-ii-1));
        aa = a[2];
        a[2] = a[1];
        a[1] = a[0];
        a[0] = aa;
        Move.push_back(make_pair('+', ii));
        Move.push_back(make_pair('-', m-jj-1));
        Move.push_back(make_pair('+', ii));
        Move.push_back(make_pair('-', m-jj-1));
        return;
    }

    if(a[0] == a[3]){
        Move.push_back(make_pair('-', m-jj-1));
        Move.push_back(make_pair('+', m-ii-1));
        Move.push_back(make_pair('-', m-jj-1));
        Move.push_back(make_pair('+', m-ii-1));
        Move.push_back(make_pair('+', ii));
        Move.push_back(make_pair('-', m-jj-1));
        Move.push_back(make_pair('+', ii));
        Move.push_back(make_pair('-', m-jj-1));
        Move.push_back(make_pair('+', ii));
        Move.push_back(make_pair('-', m-jj-1));
        Move.push_back(make_pair('+', ii));
        Move.push_back(make_pair('-', m-jj-1));
        return;
    }

}

void GetSq(){
    Move.clear();
    bool mis = false;
    vector<vector<int> > A;
    scanf("%d", &n);
    m = 2*n;
    A.resize((m+2));
    vector<vector<int> > B; B.resize(m+2); for(int i = 0; i < m+2; i++) B[i].assign(m+2, 0);
    int x;
    for(int i = 0; i < m; i++) for(int j = 0; j < m; j++) {scanf("%d", &x); A[i].push_back(x);}

    vector<int> k4k, k4, kk4;
    k4.clear();
    k4.push_back(A[0][0]); k4.push_back(A[0][m-1]);
    k4.push_back(A[m-1][m-1]); k4.push_back(A[m-1][0]);
    kk4 = k4; sort(k4.begin(), k4.end());

    for(int i = 0; i < n; i++){ // creating array B
        if(mis) break;
        for(int j = 0; j < n; j++){
            k4k.clear();
            k4k.push_back(A[i][j]); k4k.push_back(A[i][m-j-1]);
            k4k.push_back(A[m-i-1][m-j-1]); k4k.push_back(A[m-i-1][j]); sort(k4k.begin(), k4k.end());
            if(k4 != k4k){printf("-1\n"); return;}

            k4k.clear();
            k4k.push_back(A[i][j]); k4k.push_back(A[i][m-j-1]);
            k4k.push_back(A[m-i-1][m-j-1]); k4k.push_back(A[m-i-1][j]);
            if(check(k4k, kk4)) { B[i][j] = 1; B[i][m-1-j] = 1; B[m-1-i][m-1-j] = 1; B[m-1-i][j] = 1; }
        }
    }



    for(int i = 1; i < n; i++) if(B[0][i] == 1){                                                    //this
        Move.push_back(make_pair('-', i));
        for(int j = 0; j < n; j++) B[j][i] = B[j][m-1-i] = B[m-1-j][i] = B[m-1-j][m-1-i] = 1-B[j][i];
    }
    for(int i = 1; i < n; i++) if(B[i][0] == 1){                                                    //is
        Move.push_back(make_pair('+', i));
        for(int j = 0; j < n; j++) B[i][j] = B[m-1-i][j] = B[i][m-1-j] = B[m-1-i][m-1-j] = 1-B[i][j];
    }
    for(int i = 0; i < n; i++) for(int j = 0; j < n; j++) if(B[i][j] == 1){printf("-1\n"); return;} //checking

    for(int i = 0; i < n; i++) for(int j = 0; j < n; j++){
        k4k.clear();
        k4k.push_back(A[i][j]); k4k.push_back(A[i][m-j-1]);
        k4k.push_back(A[m-i-1][m-j-1]); k4k.push_back(A[m-i-1][j]);
        mov(k4k, kk4, i, j);
    }

    /*for(int i = 0; i < m; i++){
        for(int j = 0; j < m; j++) printf("%d ", B[i][j]);
        printf("\n");
    }*/
    printf("%d\n", Move.size());
    for(int i = 0; i < Move.size(); i++) printf("%c%d\n", Move[i].first, Move[i].second+1);
}


int main(){
    freopen("square.in", "r", stdin);
    freopen("square.out", "w", stdout);
    int tt;
    scanf("%d", &tt);
    for(int ttt = 0; ttt < tt; ttt++) GetSq();

    fclose(stdin);
    fclose(stdout);
    return 0;
}
